drop trigger if exists apk_recommend_limit;
drop trigger if exists view_apk_recommend_insert;
drop view if exists view_apk_recommend;
drop table if exists apk_recommend;
drop trigger if exists search_history_limit;
drop trigger if exists view_apk_installed_insert;
drop trigger if exists view_apk_installed_delete;
drop view if exists view_apk_installed;
drop view if exists view_apk_info;
drop table if exists apk_installed;
create trigger if not exists search_history_limit after insert on search_history begin delete from search_history where keyword in (select keyword from search_history order by last_search desc limit -1 offset 50); end;
create table if not exists apk_installed (apk_name text not null primary key, title text not null collate nocase, version_code integer not null, version_name text not null, isNeedUpdateAndUrl text, icon text null, unique(apk_name));
create view if not exists view_apk_installed as select apk_name, title, icon, version_code, version_name, isNeedUpdateAndUrl from apk_installed order by apk_name;
create trigger if not exists view_apk_installed_insert instead of insert on view_apk_installed for each row begin insert or replace into apk_installed (apk_name, title, icon, version_code, version_name, isNeedUpdateAndUrl) values (new.apk_name, new.title, new.icon, new.version_code, new.version_name, new.isNeedUpdateAndUrl); end;
create trigger if not exists view_apk_installed_delete instead of delete on view_apk_installed for each row begin delete from apk_installed where apk_name = old.apk_name; end;
create table if not exists recent_launch (apk_name text not null primary key, last_launch timestamp not null default (datetime('now','localtime')), unique (apk_name));
create table if not exists pop_message (content text, type text, key text not null, start_time text, end_time text, issue integer default 0, isread integer default 0);
create index if not exists recent_launch_last_launch_idx on recent_launch(last_launch);
create view if not exists view_recent_launch as select apk_name from recent_launch order by last_launch desc;
create trigger if not exists view_recent_launch_insert instead of insert on view_recent_launch for each row begin insert or replace into recent_launch (apk_name) values (new.apk_name); end;
create trigger if not exists recent_launch_limit after insert on recent_launch begin delete from recent_launch where apk_name in (select apk_name from recent_launch order by last_launch desc limit -1 offset 12); end;
create table if not exists most_launch (apk_name text not null primary key, launch_count integer not null default 0, unique (apk_name));
create index if not exists most_launch_launch_count_idx on most_launch(launch_count);
drop view if exists view_most_launch;
create view if not exists view_most_launch as select apk_name, launch_count from most_launch order by launch_count desc;
create trigger if not exists view_most_launch_insert instead of insert on view_most_launch for each row begin insert or ignore into most_launch (apk_name) values (new.apk_name); update or replace most_launch set launch_count = launch_count + 1 where apk_name = new.apk_name; end;
update configuration set field='issue_apk_top' where field='issue_top';
create table if not exists bookmark (url text not null primary key collate nocase, title text collate nocase, last_modified timestamp not null default (datetime('now','localtime')), unique (url) );
create index if not exists bookmark_last_modified_idx on bookmark(last_modified);
create view if not exists view_bookmark as select url, title from bookmark order by last_modified desc;
create trigger if not exists view_bookmark_insert instead of insert on view_bookmark for each row begin insert or replace into bookmark (url, title) values (new.url, new.title); end;
create trigger if not exists view_bookmark_delete instead of delete on view_bookmark for each row begin delete from bookmark where url = old.url; end;
drop view if exists view_webview_history;
create view if not exists view_webview_history as select url, title, last_visit from webview_history order by last_visit desc;
create trigger if not exists view_webview_history_insert instead of insert on view_webview_history for each row begin insert or replace into webview_history (url, title) values (new.url, new.title); end;
create trigger if not exists view_webview_history_delete instead of delete on view_webview_history for each row begin delete from webview_history where url = old.url; end;
create trigger if not exists view_recent_launch_delete instead of delete on view_recent_launch for each row begin delete from recent_launch where apk_name = old.apk_name; end;
create trigger if not exists view_most_launch_delete instead of delete on view_most_launch for each row begin  delete from most_launch where apk_name = old.apk_name; end;
create table if not exists most_visit (url text not null primary key collate nocase, title text collate nocase, visit_count integer not null default 0, unique (url));
create index if not exists most_visit_visit_count_idx on most_visit(visit_count);
create view if not exists view_most_visit as select url, title, visit_count from most_visit order by visit_count desc;
create trigger if not exists view_most_visit_insert instead of insert on view_most_visit for each row begin insert or ignore into most_visit (url, title) values (new.url, new.title); update or replace most_visit set visit_count = visit_count + 1 where url = new.url; end;
create trigger if not exists view_most_visit_delete instead of delete on view_most_visit for each row begin delete from most_visit where url = old.url; end;
create table if not exists most_visit_x (url text not null primary key collate nocase, title text collate nocase, visit_count integer not null default 0, unique (url));
create index if not exists most_visit_x_visit_count_idx on most_visit_x(visit_count);
create view if not exists view_most_visit_x as select url, title, visit_count from most_visit_x order by visit_count desc;
create trigger if not exists view_most_visit_x_insert instead of insert on view_most_visit_x for each row begin insert or ignore into most_visit_x (url, title) values (new.url, new.title); update or replace most_visit_x set visit_count = visit_count + 1 where url = new.url; end;
create trigger if not exists view_most_visit_x_delete instead of delete on view_most_visit_x for each row begin delete from most_visit_x where url = old.url; end;
create table if not exists floating_famous (url text not null primary key collate nocase, title text collate nocase, icon_large text collate nocase, visit_count integer not null default 0, unique (url));
create index if not exists floating_famous_visit_count_idx on floating_famous(visit_count);
create view if not exists view_floating_famous as select url, title, icon_large, visit_count from floating_famous order by visit_count asc;
create trigger if not exists view_floating_famous_insert instead of insert on view_floating_famous for each row begin insert or ignore into floating_famous (url, title, icon_large) values (new.url, new.title, new.icon_large); update or replace floating_famous set visit_count = visit_count + 1 where url = new.url; end;
create trigger if not exists view_floating_famous_delete instead of delete on view_floating_famous for each row begin delete from floating_famous where url = old.url; end;
create table if not exists reading_history (_id integer primary key autoincrement, novel_id integer, novel blob, local integer default 0);
create table if not exists download_video (_id integer primary key autoincrement, download_id text not null, title text not null, summary text, download_type text, download_url text, icon_url text, is_group integer, group_id text, group_name text, child_index integer, video_src text, video_type text, video_definition text, video_format text, video_extra_1 text, video_extra_2 text, download_state integer, total_size long, complete_size long, download_thread_infos text, additional_info text, unique (download_id) );
create table if not exists webview_cache (field text not null primary key collate nocase, status text collate nocase, unique (field));
create table if not exists video_play_history (_id  integer primary key autoincrement, play_id  text  unique, title  text, is_group  text, group_id  text, group_name  text, child_index  text, video_src  text, video_type  text, video_format  text, video_source  text, video_play_time  integer, video_play_date  integer, is_local integer default 0);
create table if not exists download_novel_new (_id integer primary key autoincrement, download_id text not null, title text , summary text, download_type text, download_url text, icon_url text, download_state integer, total_size long, complete_size long, download_thread_infos text, novel text, additional_info text, is_update integer, novel_type text, novel_extra_1 text, novel_extra_2 text, error_code integer, unique (download_id) );