function getUrls(url)
	local ret = {}
	local vid,sid = getIds(url)
    if(vid and sid) then
        local key = genKey()
        local dataUrl = "http://api.letv.com/mms/out/common/geturl?platid=3&splatid=301&&playid=0&vtype=9,13,21&version=2.0&tss=no&mmsid="
                .. sid .. "&vid=" .. vid .. "&tkey=" .. key
        Log:d(log_tag,"got dataUrl:"..dataUrl)
        local data = getData(dataUrl)
        if data then
            ret = getRes(data)
        end
    end
    Log:d(log_tag,"got letv json:"..json.encode(ret))
	return json.encode(ret)
end

function getData( url )
    local ret = {}
    local QUALITY_MAP = {["9"]="level_1",["13"]="level_2",["21"]="level_3"}
    local jsonStr = FinderUtils:getUrlContent(url)
    if not_empty(jsonStr) then
        local jsonObject = json.decode(jsonStr, 1, nil)
        local infos = jsonObject["data"][1]["infos"]
        for k,v in pairs(infos) do
            local vurl,qtype = v["mainUrl"], v["vtype"]
            qtype = QUALITY_MAP[qtype];
            if qtype then
                ret[qtype] = vurl 
            end
        end
    end 
    return ret
end

function getRes( data )
    local  ret = {}
    for qtype,url in pairs(data) do
        url = url.."&format=1&expect=3&termid=2&pay=0&ostype=android&hwtype=un&_r=0"
        local jsonStr = FinderUtils:getUrlContent(url)
        if not_empty(jsonStr) then
            local jsonObject = json.decode(jsonStr, 1, nil)
            if jsonObject and jsonObject["location"] then
                local location = jsonObject["location"]
                local strings = wrap_list_proxy(Arrays:asList(FinderUtils:getFinalUrlAndType(location)))
                local finalurl,vtype,vlength = strings[0],strings[1],strings[2]
                if(finalurl and vtype) then
                    if(ret[vtype]) then
                        ret[vtype][qtype] = {length=vlength,url=finalurl}
                    else
                        ret[vtype] = {[qtype]={length=vlength,url=finalurl}}
                    end
                end
            end
        end
    end
    return ret
end

function getIds( url )
    local content = FinderUtils:getUrlContent(url)
    local s1,e1,vid  = string.find(content,'"vid":"(%d+)"')
    local s2,e2,sid  = string.find(content,'"mmsid":"([^"]+)"')
    if(s1 and s2) then
        return vid,sid
    end
end

function genKey()
    local time = os.time()
    for i=0,7 do
        local e = FinderUtils:mathInt32(1,time,"&")
        time = FinderUtils:mathInt32(time,1,">>")
        e = FinderUtils:mathInt32(e,32,"<<")
        time = FinderUtils:mathInt32(time,e,"+")
    end
    local key = FinderUtils:mathInt32(time,185025305,"^")
    return key
end

